include    GDIpBmpToJPG.inc

.data
jpegFile            db 'test.jpg',0
ImgType             db 'image/jpeg',0
message             db 'BMP file converted to JPG',0
caption             db 'GDI+ demo',0
ImgQuality          dd  90
_EncoderQuality     GUID <01d5be4b5h,0fa4ah,0452dh,<09ch,0ddh,05dh,0b3h,051h,05h,0e7h,0ebh>>

.data?
StartupInfo         GdiplusStartupInput <?>
buffer              db 32 dup(?)
pImageCodecInfo     dd ?
token               dd ?
BmpImage            dd ?
eps                 EncoderParameters <?>

.code

start:

    mov         eax,OFFSET StartupInfo
    mov         GdiplusStartupInput.GdiplusVersion[eax],1
                                                 ; must be always seto to 1
    invoke      GdiplusStartup,ADDR token,ADDR StartupInfo,0

    mov         eax,OFFSET pImage
    mov         ecx,BITMAPFILEHEADER.bfOffBits[eax]
    lea         edx,[eax+ecx]                    ; points the array of bytes that contains the pixel data
    add         eax,SIZEOF BITMAPFILEHEADER      ; points the BITMAPINFO structure
    invoke      GdipCreateBitmapFromGdiDib,eax,edx,ADDR BmpImage
                                                 ; creates a Bitmap object based on a BITMAPINFO structure and
                                                 ; an array of pixel data

    invoke     UnicodeStr,ADDR jpegFile,ADDR buffer
    mov        esi,OFFSET eps
    mov        EncoderParameters.Count[esi],1
    lea        ecx,[esi+EncoderParameters.Parameter.pGUID]
    invoke     MemCopy,ADDR _EncoderQuality,ecx,16    ; copy the GUID ot the correct address
    mov        EncoderParameters.Parameter.vType[esi],EncoderParameterValueTypeLong
    mov        EncoderParameters.Parameter.NumberOfValues[esi],1
                                                ; we have only one EncoderParameter structure
    mov        EncoderParameters.Parameter.value[esi],OFFSET ImgQuality
                                                ; set the JPEG compression level
    invoke     GetEncoderClsid,ADDR ImgType,ADDR pImageCodecInfo
                                                ; get the class identifier (CLSID) of the encoder
                                                ; The encoder can be bmp,jpeg,gif,tiff or png

    invoke     GdipSaveImageToFile,BmpImage,ADDR buffer,eax,ADDR eps
                                                ; save the image file

    invoke     VirtualFree,pImageCodecInfo,0,MEM_RELEASE

    invoke     GdipDisposeImage,BmpImage        ; release the image
    invoke     GdiplusShutdown,token            ; shutdown the GDI+ system
    invoke     MessageBox,0,ADDR message,ADDR caption,MB_OK
    invoke     ExitProcess,0

GetEncoderClsid PROC USES ebx edi sMimeType:DWORD,pMem:DWORD

LOCAL numEncoders:DWORD
LOCAL nSize:DWORD
LOCAL _buffer[32]:BYTE

    invoke     GdipGetImageEncodersSize,ADDR numEncoders,ADDR nSize
    invoke     VirtualAlloc,0,nSize,MEM_COMMIT,PAGE_READWRITE
    mov        edi,eax
    mov        eax,pMem                             ; = pImageCodecInfo
    mov        DWORD PTR [eax],edi
    invoke     GdipGetImageEncoders,numEncoders,nSize,edi
    invoke     UnicodeStr,sMimeType,ADDR _buffer
    mov        ebx,numEncoders
@@:
    invoke     StrCmpW,ADDR _buffer,ImageCodecInfo.MimeType[edi]
    test       eax,eax
    jnz        @f
    sub        ebx,1
    add        edi,SIZEOF ImageCodecInfo
    jmp        @b
@@:
    mov        eax,edi                              ; = lea    eax,[edi+ImageCodecInfo.Clsid]
    ret

GetEncoderClsid ENDP

END start
